//
//  twDemo1ViewController.m
//  twDemo1
//
//  Created by tpw on 7/24/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "twDemo1ViewController.h"

@implementation twDemo1ViewController

@synthesize label1;

@synthesize gameSession,gamePeerID,lastHeartbeatDate;




// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    gameSession = nil;
	gamePeerID = nil;
	lastHeartbeatDate = nil;
	NSString *uid = [[UIDevice currentDevice] uniqueIdentifier];
	gameUniqueID = [uid hash];
    
}


-(IBAction)startPicker {
	if (!gamePeerID) {
		GKPeerPickerController *picker =
		[[GKPeerPickerController alloc] init];
		picker.delegate = self;
		picker.connectionTypesMask =
		GKPeerPickerConnectionTypeNearby;
		[picker show];
	}
}

-(GKSession*) peerPickerController: (GKPeerPickerController*) controller sessionForConnectionType: (GKPeerPickerConnectionType) type {
	if (!gameSession) {
		gameSession = [[GKSession alloc]
					   initWithSessionID:tpwGameSession
					   displayName:nil
					   sessionMode:GKSessionModePeer];
		gameSession.delegate = self;
	}
	return gameSession;
}

- (void)peerPickerController:(GKPeerPickerController *)picker didConnectPeer:(NSString *)peerID toSession:(GKSession *)session {
    // Remember the current peer.
	self.gamePeerID = peerID;  // copy
	
	// Make sure we have a reference to the game session and it is set up
	self.gameSession = session; // retain
	self.gameSession.delegate = self; 
	[self.gameSession setDataReceiveHandler:self withContext:NULL];
	
	// Done with the Peer Picker so dismiss it
    
	[session retain]; 
	[picker dismiss];
    picker.delegate = nil;
	[picker release];
}

- (void)peerPickerControllerDidCancel:(GKPeerPickerController *)picker {
	gamePeerID = nil;
    // invalidate and release game session if one is around.
	if(self.gameSession != nil)	{
		[self invalidateSession:self.gameSession];
		self.gameSession = nil;
	}
    
	[picker release];
}

#pragma mark -
#pragma mark Session Related Methods

//
// invalidate session
//
- (void)invalidateSession:(GKSession *)session {
	if(session != nil) {
		[session disconnectFromAllPeers]; 
		session.available = NO; 
		[session setDataReceiveHandler: nil withContext: NULL]; 
		session.delegate = nil; 
	}
}

- (void)session:(GKSession *)session peer:(NSString *)peerID didChangeState:(GKPeerConnectionState)state { 
	switch (state) 
    { 
        case GKPeerStateConnected: 
            // Connection was accepted
			[session setDataReceiveHandler: self withContext: nil]; 
			gamePeerID = peerID;	
			break; 
            
        case GKPeerStateAvailable:
            // A peer became available by starting app, exiting settings.
            break;
        case GKPeerStateUnavailable:
            // Peer unavailable due to joining a call, leaving app, or entering settings.
            break;
        case GKPeerStateDisconnected:
            //  ended either manually or due to failure somewhere.
            break;
        case GKPeerStateConnecting:
            // Peer is attempting to connect to the session.
            break;
        default:
            break;        

    } 
    
} 



//////////////////////

//- (IBAction)beepSound:(id) sender  {
- (IBAction)beepSound  {
    
    //if ([label1.text isEqual:@"BEEP!"])
    if ([label1.text rangeOfString:@"BEEP!"].location == NSNotFound)
        label1.text = @"BEEP!";
    else
        label1.text = @".....";

    //vibrate too
    AudioServicesPlayAlertSound(kSystemSoundID_Vibrate);
    
    
    NSString *pathForSilentFile = [[NSBundle mainBundle] pathForResource:@"twBeep" ofType:@"mp3"];
	NSURL *soundFile = [[NSURL alloc] initFileURLWithPath:pathForSilentFile];
	AVAudioPlayer *sPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:soundFile error:NULL];
	[soundFile release];
	[sPlayer prepareToPlay];	
	[sPlayer play];
    
}

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
}
*/

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    //manually added tpw below
	self.lastHeartbeatDate = nil;
	// cleanup the session
	[self invalidateSession:self.gameSession];
	self.gameSession = nil;
	self.gamePeerID = nil;
	
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait
            || interfaceOrientation == UIInterfaceOrientationLandscapeLeft
            ||  interfaceOrientation == UIInterfaceOrientationLandscapeRight);
}

@end
